%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                                                                      %
%  TeXnous theme for LaTeX beamer class.                                                                               %
%  XeLaTeX or LuaLaTeX compilator needed.                                                                              %
%                                                                                                                      %
%  Author: Kirill Chuvilin <k.chuvilin@texnous.org>, 2017                                                              %
%  Copyright: 2017 Kirill Chuvilin                                                                                     %
%  License: BSD-3-Clause                                                                                               %
%                                                                                                                      %
%  Redistribution and use in source and binary forms, with or without modification, are permitted provided that        %
%  the following conditions are met:                                                                                   %
%                                                                                                                      %
%  1. Redistributions of source code must retain the above copyright notice, this list of conditions and               %
%  the following disclaimer.                                                                                           %
%                                                                                                                      %
%  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and            %
%  the following disclaimer in the documentation and/or other materials provided with the distribution.                %
%                                                                                                                      %
%  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote     %
%  products derived from this software without specific prior written permission.                                      %
%                                                                                                                      %
%  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,  %
%  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE   %
%  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  %
%  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS        %
%  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY              %
%  OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY     %
%  WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                             %
%                                                                                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage{currfile}% monitor include paths
\RequirePackage{\currfiledir texnous_beamer}% common definitions for TeXnous
\ProvidesPackage{\currfiledir beamerthemeTeXnous}[\@texnous@releaseDate\space TeXnous theme for beamer]
\texnous@processOptions% process options

\RequirePackage{collect}% to collect environment contents



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Theme parts
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\RequirePackage{\@texnous@resourceDir beamercolorthemeTeXnous}%
\RequirePackage{\@texnous@resourceDir beamerfontthemeTeXnous}%
\RequirePackage{\@texnous@resourceDir beamerouterthemeTeXnous}%
\RequirePackage{\@texnous@resourceDir beamerinnerthemeTeXnous}%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\mode<presentation>
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wide page
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newenvironment{wideframe}[1][]{%
	\texnous@checkArgument[]{%
		% @ isn't interpreted as letter after frame begin
		\let\beamerleftmargin\beamer@leftmargin%
		\let\beamerrightmargin\beamer@rightmargin%
		\begin{frame}[fragile,environment=wideframe,#1]{##1}%
			\begin{addmargin}[-\beamerleftmargin]{-\beamerrightmargin}% remove horizontal margins
				\begin{addmargin}[\texnouslength{wide page margin left}]{\texnouslength{wide page margin right}}% add horizontal margins
					\textwidth=\linewidth%
					\columnwidth=\linewidth%
					\usebeamerfont*{wide page}%
	}%
}{%
			\end{addmargin}%
		\end{addmargin}%
	\end{frame}%
}

\newtexnouslength{wide page margin left}
\newtexnouslength{wide page margin right}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Contact page
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%
% Frame with contacts
% \begin{contactframe}...\end{contactframe}
%%
\newenvironment{contactframe}{%
	\@nameuse{collectinmacro}{\@contactframe@contents}{}{}% start text collection
}{%
	\@nameuse{endcollectinmacro}% stop text collection
	\newcount\@c@contactframe@person% counter of the persons
	\@c@contactframe@person0% there is no persons at the start
	\let\person\contactframe@person\let\endperson\endcontactframe@person% person environment alias
	\let\name\contactframe@name% name command alias
	\let\contact\contactframe@contact% contact command alias
	\begin{frame}%
		\begin{texnous@suppress}\@contactframe@contents\end{texnous@suppress}%
		\edef\@contactframe@personCount{\the\@c@contactframe@person}% store the total number of persons
		\@c@contactframe@person0% reset iterator
		\ifnum\@contactframe@personCount=0{% if there are no persont environemtns
			\begin{person}\@contactframe@contents\end{person}% make one from all the contents
			\edef\@contactframe@personCount{1}% update the total number of persons
			\@c@contactframe@person0% reset iterator
		}\fi%
		\ifnum\@contactframe@personCount>6\def\@contactframe@personCount{6}\fi% dont display more than 6
		\begin{texnous@clearFrame}[c]%
			\usebeamertemplate{contact page}%
		\end{texnous@clearFrame}%
	\end{frame}%
}

%%
% Include person to the contact frame
%%
\newenvironment{contactframe@person}{%
	\expandafter\gdef\csname @contactframe@person\the\@c@contactframe@person @name\endcsname{}% reset name
	\expandafter\gdef\csname @contactframe@person\the\@c@contactframe@person @contact\endcsname{}% reset contact
	\expandafter\gdef\csname @contactframe@person\the\@c@contactframe@person @contactType\endcsname{}% reset contact
	\begin{texnous@suppress}%
}{%
	\end{texnous@suppress}%
	\global\advance\@c@contactframe@person1% go to the next person
}

%%
% Include person name to the contact frame
%%
\newcommand<>{\contactframe@name}[1]{\only#2{%
	\expandafter\gdef\csname @contactframe@person\the\@c@contactframe@person @name\endcsname{#1}% store name
}}

%%
% Include person contact to the contact frame
%%
\newcommand<>{\contactframe@contact}[2]{\only#3{%
	\expandafter\gdef\csname @contactframe@person\the\@c@contactframe@person @contact\endcsname{#2}% store contact
	\expandafter\gdef\csname @contactframe@person\the\@c@contactframe@person @contactType\endcsname{#1}% store contact type
}}


\setbeamertemplate{contact page}{%
	\usebeamertemplate{contact page title}
	\vskip-1pt%
	\usebeamertemplate{contact page persons}
}


\newtexnouslength{contact page title margin top}
\newtexnouslength{contact page title margin bottom}
\newtexnouslength{contact page title margin left}
\newtexnouslength{contact page title margin right}

\setbeamertemplate{contact page title}{%
	\vspace{\texnouslength{contact page title margin top}}%
	\begin{texnous@box}{\linewidth}{}[\texnouslength{contact page title margin left}][\texnouslength{contact page title margin right}]%
		\hyphenpenalty=10000%
		\flushleft%
		\usebeamerfont*{contact page title}%
		\@texnous@contactsTitle%
	\end{texnous@box}%
	\vspace{\texnouslength{contact page title margin bottom}}%
}


\newtexnouslength[\fill]{contact page persons margin top}
\newtexnouslength[\fill]{contact page persons margin bottom}
\newtexnouslength{contact page persons margin left}
\newtexnouslength{contact page persons margin right}

\setbeamertemplate{contact page persons}{%
	\vspace{\texnouslength{contact page persons margin top}}%
	\begin{texnous@box}{\linewidth}{}[\texnouslength{contact page persons margin left}][\texnouslength{contact page persons margin right}]%
		\usebeamerfont*{contact page}%
		\flushleft%
		\hspace{0pt}%
		\loop\ifnum\the\@c@contactframe@person<\@contactframe@personCount% for all the persons
			\usebeamertemplate{contact page person}%
			\hfill%
			\advance\@c@contactframe@person1% go to the next person
		\repeat%
	\end{texnous@box}%
	\vspace{\texnouslength{contact page persons margin bottom}}%
}


\newtexnouslength{contact page person width}
\newtexnouslength{contact page person height}
\newtexnouslength{contact page contact icon width}
\newtexnouslength{contact page contact icon margin}

\setbeamertemplate{contact page person}{%
	\begin{texnous@box}{\texnouslength{contact page person width}}{\texnouslength{contact page person height}}%
		\flushleft%
		\csname @contactframe@person\the\@c@contactframe@person @name\endcsname%
		\expandafter\ifx\csname @contactframe@person\the\@c@contactframe@person @contactType\endcsname\empty\else% if the contact is defined
			\par%
			\raisebox{-0.3\baselineskip}{%
				\begin{texnous@box}{\texnouslength{contact page contact icon width}}{}%
					\includecontacticon{\csname @contactframe@person\the\@c@contactframe@person @contactType\endcsname}
				\end{texnous@box}%
			}%
			\hspace{\texnouslength{contact page contact icon margin}}%
			\csname @contactframe@person\the\@c@contactframe@person @contact\endcsname%
		\fi%
	\end{texnous@box}%
}

\newcommand\includecontacticon[1]{\includegraphics[width=\textwidth,keepaspectratio]{\@texnous@resourceDir contact-icon_#1.pdf}}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Quote page
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%
% Frame with a quote
% \begin{quoteframe}[#1]...\end{quoteframe}
% #1 - the author
%%
\newenvironment{quoteframe}[1][]{%
	\let\author\quoteframe@author% local alias for the command
	\author{#1}% set author from the optional argument
	\@nameuse{collectinmacro}{\@quoteframe@text}{}{}% start text collection
		\ignorespaces%
}{%
	\@nameuse{endcollectinmacro}% stop text collection
	\begin{frame}%
		\begin{texnous@clearFrame}[c]%
			\usebeamertemplate{quote page}%
		\end{texnous@clearFrame}%
	\end{frame}%
}

%%
% Set author for the quote frame
% #1 - the author
%%
\newcommand<>{\quoteframe@author}[1]{\only#2{
	\gdef\@quoteframe@author{#1}% store the author
	\ignorespaces%
}}%

\setbeamertemplate{quote page}{%
	\usebeamertemplate{quote page text box}
	\vskip-1pt%
	\usebeamertemplate{quote page author box}
}

\newtexnouslength[\fill]{quote page text margin top}
\newtexnouslength[\fill]{quote page text margin bottom}
\newtexnouslength{quote page text margin left}
\newtexnouslength{quote page text margin right}
\newtexnouslength{quote page text line width}
\newtexnouslength{quote page text padding left}
\newtexnouslength{quote page text padding top}
\newtexnouslength{quote page text padding bottom}

\setbeamertemplate{quote page text box}{%
	\vspace{\texnouslength{quote page text margin top}}%
	\begin{texnous@box}[c]{\textwidth}{}[\texnouslength{quote page text margin left}][\texnouslength{quote page text margin right}]%
		\begin{@texnous@quote}{\texnouslength{quote page text line width}}{\texnouslength{quote page text padding left}}{\texnouslength{quote page text padding top}}{\texnouslength{quote page text padding bottom}}%
			\usebeamerfont*{quote page}%
			\hyphenpenalty=10000%
			\flushleft%
			\@quoteframe@text% insert collected text
		\end{@texnous@quote}%
	\end{texnous@box}%
	\vspace{\texnouslength{quote page text margin bottom}}%
}

\newtexnouslength{quote page author height}
\newtexnouslength{quote page author margin top}
\newtexnouslength{quote page author margin bottom}
\newtexnouslength{quote page author margin left}
\newtexnouslength{quote page author margin right}

\setbeamertemplate{quote page author box}{%
	\vspace{\texnouslength{quote page author margin top}}%
	\begin{texnous@box}[t]{\textwidth}{\texnouslength{quote page author height}}[\texnouslength{quote page author margin left}][\texnouslength{quote page author margin right}]%
		\usebeamerfont*{quote page author}%
		\flushleft%
		\@quoteframe@author%
		\hfill%
	\end{texnous@box}%
	\vspace{\texnouslength{quote page author margin bottom}}%
}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure page
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%
% Frame with figures
% \begin{figureframe}#1...\end{figureframe}
% #1 - frame title
%%
\newenvironment{figureframe}{%
	\@nameuse{collectinmacro}{\@figureframe@contents}{}{}% start text collection
		\texnous@checkArgument{\ifx&####1&\else\frametitle{####1}\fi}%
}{%
	\@nameuse{endcollectinmacro}% stop text collection
	\newcount\@c@figureframe@figure% counter of the figures
	\@c@figureframe@figure0% there is no figures at the start
	\let\figure\figureframe@figure\let\endfigure\endfigureframe@figure% figure environment alias
	\let\caption\figureframe@caption% caption command alias
	\begin{frame}%
		\begin{texnous@suppress}\@figureframe@contents\end{texnous@suppress}%
		\edef\@figureframe@figureCount{\the\@c@figureframe@figure}% store the total number of figures
		\@c@figureframe@figure0% reset iterator
		\ifnum\@figureframe@figureCount<2{% if there is one figure
			\ifnum\@figureframe@figureCount=0% if there are no figure environemtns
				\begin{figure}\@figureframe@contents\end{figure}% make one from all the contents
				\edef\@figureframe@figureCount{1}% update the total number of figures
				\@c@figureframe@figure0% reset iterator
			\fi%
			\usebeamertemplate{1 figure page}%
		}\else{% if there are several figures
			\ifnum\@figureframe@figureCount>5\def\@figureframe@figureCount{5}\fi% dont display more than
			\begin{addmargin}[-\beamer@leftmargin]{-\beamer@rightmargin}% remove horizontal margins
				\usebeamertemplate{multiple figure page}%
			\end{addmargin}%
		}\fi%
	\end{frame}%
}

%%
% Include figure to the figure frame
%%
\newenvironment{figureframe@figure}{%
	\expandafter\gdef\csname @figureframe@caption\the\@c@figureframe@figure\endcsname{}% reset caption
	\@nameuse{collectinmacro}{\@figureframe@figure}{}{}%
}{%
	\@nameuse{endcollectinmacro}% stop text collection
	\global\expandafter\let\csname @figureframe@figure\the\@c@figureframe@figure\endcsname\@figureframe@figure%
	\global\advance\@c@figureframe@figure1% go to the next figure
}

%%
% Include figure caption to the figure frame
%%
\newcommand<>{\figureframe@caption}[1]{\only#2{%
	\expandafter\gdef\csname @figureframe@caption\the\@c@figureframe@figure\endcsname{#1}% store caption
}}


\newtexnouslength{1 figure page padding left}
\newtexnouslength{1 figure page padding right}

\setbeamertemplate{1 figure page}{%
	\ifx\insertframetitle\empty% if there is no title
		\begin{texnous@clearFrame}[c]%
			\csname @figureframe@figure\the\@c@figureframe@figure\endcsname% insert the figure code
			\expandafter\ifx\csname @figureframe@caption0\endcsname\empty\else% if the caption is defined
				\texnous@resetFrame% start the frame again
				\usebeamertemplate{1 figure page caption}%
			\fi%
		\end{texnous@clearFrame}%
	\else% is there is a title
		\let\caption\footline% write a caption to the footline
		\begin{addmargin}[-\beamer@leftmargin]{-\beamer@rightmargin}% remove horizontal margins
			\begin{texnous@box}[c]{\linewidth}{}[\texnouslength{1 figure page padding left}][\texnouslength{1 figure page padding right}]%
				\csname @figureframe@figure\the\@c@figureframe@figure\endcsname% insert the figure code
			\end{texnous@box}%
		\end{addmargin}%
	\fi%
}


\newtexnouslength{1 figure page caption width}
\newtexnouslength[\fill]{1 figure page caption margin top}
\newtexnouslength{1 figure page caption margin bottom}
\newtexnouslength{1 figure page caption margin left}
\newtexnouslength{1 figure page caption margin right}
\newtexnouslength{1 figure page caption padding top}
\newtexnouslength{1 figure page caption padding bottom}
\newtexnouslength{1 figure page caption padding left}
\newtexnouslength{1 figure page caption padding right}

\setbeamertemplate{1 figure page caption}{%
	\vspace{\texnouslength{1 figure page caption margin top}}%
	\begin{texnous@box}[c]{\texnouslength{1 figure page caption width}}{}[\texnouslength{1 figure page caption margin left}][\texnouslength{1 figure page caption margin right}]%
		\begin{beamercolorbox}{figure page caption}%
			\vskip-1pt%
			\vspace{\texnouslength{1 figure page caption padding top}}%
			\begin{texnous@box}[c]{\linewidth}{}[\texnouslength{1 figure page caption padding left}][\texnouslength{1 figure page caption padding right}]%
				\flushleft%
				\usebeamerfont*{figure page caption}%
				\csname @figureframe@caption\the\@c@figureframe@figure\endcsname% insert caption
			\end{texnous@box}%
			\vspace{\texnouslength{1 figure page caption padding bottom}}%
		\end{beamercolorbox}%
	\end{texnous@box}%
	\vspace{\texnouslength{1 figure page caption margin bottom}}%
}


\newtexnouslength{2 figure page padding left}
\newtexnouslength{2 figure page padding right}
\newtexnouslength{2 figure page graphics width}
\newtexnouslength{2 figure page graphics height}
\newtexnouslength{3 figure page padding left}
\newtexnouslength{3 figure page padding right}
\newtexnouslength{3 figure page graphics width}
\newtexnouslength{3 figure page graphics height}
\newtexnouslength{4 figure page padding left}
\newtexnouslength{4 figure page padding right}
\newtexnouslength{4 figure page graphics width}
\newtexnouslength{4 figure page graphics height}
\newtexnouslength{5 figure page padding left}
\newtexnouslength{5 figure page padding right}
\newtexnouslength{5 figure page graphics width}
\newtexnouslength{5 figure page graphics height}

\setbeamertemplate{multiple figure page}{%
	\begin{texnous@box}{\linewidth}{}[\texnouslength{\@figureframe@figureCount\space figure page padding left}][\texnouslength{\@figureframe@figureCount\space figure page padding right}]%
		\loop\ifnum\the\@c@figureframe@figure<\@figureframe@figureCount% for all the figures
			\ifnum\the\@c@figureframe@figure>0\hfill\else\hspace{0pt}\fi%
			\begin{texnous@box}[c]{\texnouslength{\@figureframe@figureCount\space figure page graphics width}}{\texnouslength{\@figureframe@figureCount\space figure page graphics height}}%
				\begin{texnous@box}[c]{\textwidth}{\textheight}%
					\csname @figureframe@figure\the\@c@figureframe@figure\endcsname% insert the figure
				\end{texnous@box}%
				\usebeamertemplate{* figure page caption}%
			\end{texnous@box}%
			\advance\@c@figureframe@figure1% go to the next logo
		\repeat%
	\end{texnous@box}%
}


\newtexnouslength{* figure page caption height}
\newtexnouslength{* figure page caption margin top}
\newtexnouslength{* figure page caption margin bottom}

\setbeamertemplate{* figure page caption}{%
	\vspace{\texnouslength{* figure page caption margin top}}%
	\expandafter\ifx\csname @figureframe@caption\the\@c@figureframe@figure\endcsname\empty\else% if the caption isn't empty
		\vskip-1pt%
		\begin{texnous@box}[t]{\texnouslength{\@figureframe@figureCount\space figure page graphics width}}{\texnouslength{* figure page caption height}}%
			\hyphenpenalty=10000%
			\flushleft%
			\csname @figureframe@caption\the\@c@figureframe@figure\endcsname% insert the caption
		\end{texnous@box}%
		\vspace{-\texnouslength{* figure page caption height}}%
	\fi%
	\vspace{\texnouslength{* figure page caption margin bottom}}%
}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Listing page
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newtexnouslength{listing page listing padding top}
\newtexnouslength{listing page listing padding bottom}
\newtexnouslength{listing page listing padding left}
\newtexnouslength{listing page listing padding right}
\newtexnouslength{listing page caption margin left}
\newtexnouslength{listing page caption margin right}

%%
% Frame with listing
% \begin{listingframe}[#1]#2...\end{listingframe}
% #1 - lstlisting options
% #2 - frame title
%%
\lstnewenvironment{listingframe}[1][]{%
	\lst@Key{title}\relax{\def\lst@title{##1}}%
	\lst@Key{caption}\relax{\lstKV@OptArg[{##1}]{##1}{\def\lst@caption{####2}\def\lst@@caption{####1}}}%
	\lstset{%
		aboveskip=\texnouslength{listing page listing padding top},%
		belowskip=\texnouslength{listing page listing padding bottom},%
		xleftmargin=\texnouslength{listing page listing padding left},%
		xrightmargin=\texnouslength{listing page listing padding right},%
	}%
	\lstset{	#1}%
	\let\includelistingcaption\lst@caption%
	\global\setbox\@listingframe@savebox\vbox%
		\bgroup%
			\addmargin[-\beamer@leftmargin]{-\beamer@rightmargin}% remove horizontal margins
}{%
			\endaddmargin%
		\egroup%
	\begin{frame}[b]%
		\ifx\lst@title\empty{% if the title is't set
			\usebeamertemplate{listing page without title}%
		}\else{% if the title is set
			\frametitle{\lst@title}%
			\usebeamertemplate{listing page with title}%
		}\fi%
	\end{frame}%
}

\newsavebox{\@listingframe@savebox} % the savebox for the text
\newcommand\includelisting{%
	\hspace{\texnouslength{listing page listing padding left}}%
	\usebox{\@listingframe@savebox}%
	\hspace{\texnouslength{listing page listing padding right}}%
}

\setbeamertemplate{listing page without title}{%
	\begin{texnous@clearFrame}[t]%
		\begin{beamercolorbox}[wd=\linewidth]{listing}%
			\vbox to \textheight{\includelisting\vfill}%
		\end{beamercolorbox}%
	\end{texnous@clearFrame}%
}

\setbeamertemplate{listing page with title}{%
	\thispagestyle{texnous@nofootline}% page withoute footer
	\begin{addmargin}[-\beamer@leftmargin]{-\beamer@rightmargin}% remove horizontal margins
		\textheight=\paperheight%
		\begin{texnous@box}{\linewidth}{}[\texnouslength{listing page caption margin left}][\texnouslength{listing page caption margin right}]%
			\includelistingcaption%
		\end{texnous@box}%
		\vspace{-1pt}%
		\vfill%
		\begin{beamercolorbox}[wd=\linewidth]{listing}%
			\includelisting%
		\end{beamercolorbox}%
	\end{addmargin}%
	\vspace{-\footheight}%
}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\mode<all>
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



\endinput
